<template>
  <BaseProjectCard
    :title="dataset.title"
    :external-link="getExternalLink"
    :main-user="mainUser"
    :date="mainVersion.date"
  >
    <template #header>
      <h3 class="card-title"></h3>
      <div class="card-options w-100">
        <b-col cols="auto" class="mr-auto mt-1 px-0">
          <a class="text-datasets cursor-pointer">
            <CircleCheckIcon class="icon-right" />
          </a>
        </b-col>
        <b-col cols="auto" class="mr-1 px-0">
          <b-button
            class="btn btn-datasets btn-sm btn-configure-sce"
            :disabled="!hasFiles"
            :href="downloadLink"
            target="_blank"
          >
            <DownloadIcon class="icon-xxs" />
            Download
          </b-button>
        </b-col>
        <b-dropdown
          variant="link"
          toggle-tag="a"
          toggle-class="p-0 card-dropdown dropdown-job-actions"
          no-caret
          right
        >
          <template #button-content>
            <DotsVerticalIcon />
          </template>
          <b-dropdown-item link-class="pt-1 pb-1" disabled>
            <EyeIcon class="dropdown-item-icon" />
            Preview
          </b-dropdown-item>
          <b-dropdown-item link-class="pt-1 pb-1" disabled>
            <LetterCaseIcon class="dropdown-item-icon" />
            Rename
          </b-dropdown-item>
          <b-dropdown-item link-class="pt-1 pb-1" disabled>
            <CopyIcon class="dropdown-item-icon" />
            Duplicate
          </b-dropdown-item>
          <b-dropdown-item
            data-cy="unlink-dataset"
            link-class="pt-1 pb-1"
            @click="removeDataset()"
          >
            <TrashIcon class="dropdown-item-icon" />
            Remove
          </b-dropdown-item>
        </b-dropdown>
      </div>
    </template>
    <template #pretitle>
      <div class="card-type card-type-scenmario small">
        <span class="badge bg-datasets-lt badge-small-text text-uppercase">
          dataset
        </span>
      </div>
    </template>
    <template #subtitle>
      <div class="mt-0 mb-0">
        <span class="text-vrsion small mt-0 ml-3 mr-3">
          {{ versionString }}
        </span>
      </div>
    </template>
    <template #body-bottom>
      <div class="mt-3">
        <div class="avatar-list avatar-list-stacked">
          <Avatar
            v-b-tooltip.hover.right="{ variant: 'dark' }"
            title="RISIS Datastore"
            badge="bg-online"
          >
            <AppsIcon />
          </Avatar>
          <Avatar img="/avatars/001s.png" badge="bg-online" />
        </div>
      </div>
    </template>
    <template #description>
      <div class="mt-3 mb-2 text-justify">
        <div class="markdown lh-base small text-clamp-2 mb-0">
          {{ mainVersion.short_description }}
        </div>
        <a
          v-if="mainVersion.short_description.length > 60"
          v-b-tooltip.hover.top="{ variant: 'dark' }"
          :title="mainVersion.short_description"
          class="d-flex h6 cursor-default"
          >Learn more...</a
        >
      </div>
    </template>
    <template #badges>
      <div class="lh-sm w-100 cursor-not-allowed">
        <a class="disabled-action">
          <b-badge class="badge-small-text text-uppercase bg-indigo-lt w-100">
            <TagIcon class="icon-xxs" />
          </b-badge>
        </a>
      </div>
      &nbsp;
      <div class="lh-sm w-100">
        <a class="disabled-action">
          <b-badge class="badge-small-text text-uppercase bg-blue-lt w-100">
            <DatabaseIcon class="icon-xxs" /> {{ dataset.title }}
          </b-badge>
        </a>
      </div>
    </template>
    <template #progress>
      <b-progress class="card-progress">
        <b-progress-bar class="w-0"></b-progress-bar>
      </b-progress>
    </template>
  </BaseProjectCard>
</template>

<script>
import notificationsMixin from '~/mixins/notifications.js';

export default {
  mixins: [notificationsMixin],
  props: {
    dataset: {
      type: Object,
      default() {
        return {
          fullName: '',
          firstName: '',
        };
      },
    },
    date: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      showVersions: false,
    };
  },
  computed: {
    projectId() {
      return this.$nuxt.$route.params.id;
    },
    versionString() {
      return Object.keys(this.dataset.versions)[0];
    },
    mainVersion() {
      return this.dataset.versions[this.versionString];
    },
    mainUser() {
      return {
        firstName: this.mainVersion.authors_ids[0],
      };
    },
    downloadLink() {
      const encodedId = encodeURIComponent(this.dataset.id);
      let token = this.$auth.strategy.token.get().split(' ');
      token = token[1];
      return `${this.$config.apiRoot}/datasets/${encodedId}/files?access_token=${token}`;
    },
    hasFiles() {
      return Object.keys(this.mainVersion.files).length;
    },
    getExternalLink() {
      return `${this.$config.datastoreUrl}/loginpage.xhtml?redirectPage=/dataset.xhtml?persistentId=${this.dataset.id}&silentAutoLogin=true`;
    },
  },
  methods: {
    async removeDataset() {
      await this.$nuxt.context.store
        .dispatch('projects/unlinkDataset', {
          projectId: this.projectId,
          datasetId: this.dataset.id,
        })
        .catch(() => {
          this.showErrorNotification('Error unlinking dataset');
        });
    },
  },
};
</script>
